﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter.Events;
using System.Diagnostics;


namespace DataRecordPresenterLoadedEvent
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<person> People { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;
            People = new ObservableCollection<person>();
            for (int i = 0; i < 30; i++)
            {
                People.Add(new person { Name = "John Smith", Age = 100 });
            }
            People.Add(new person { Name = "John Smith", Age = 100 });
            People.Add(new person { Name = "Susy Smith", Age = 100 });
        }

        private void Grid_DataRecordPresenter_Loaded(object sender, RoutedEventArgs e)
        {
            DataRecordPresenter presenter = sender as DataRecordPresenter;

            // When the followng line is not commented the combo variable created in the lines below is always null
            //xamDataGrid1.FieldLayoutSettings.DataRecordPresenterStyle = xamDataGrid1.Resources["UnWire_DataRecordPresenter_Loaded"] as Style;

            if (!presenter.Record.IsDataRecord)
                return;

            var parmCell = (presenter.Record as DataRecord).Cells[0];
            CellValuePresenter parmCVP = CellValuePresenter.FromCell(parmCell);

            if (parmCVP == null)
                return;

            XamComboEditor parmEditor = parmCVP.Editor as XamComboEditor;
            
            parmEditor.StartEditMode();  
            
            var combo = parmEditor.ComboBox; // combobox should not be null here.
            var dataContext = parmEditor.DataContext; // datacontext should not be null here.

            parmEditor.EndEditMode(true, true);

            //Unwiring DRP_Loaded here causes combo and dataContext to be null for subsequent rows
            //xamDataGrid1.FieldLayoutSettings.DataRecordPresenterStyle = xamDataGrid1.Resources["UnWire_DataRecordPresenter_Loaded"] as Style;
        }

        private void Grid_DataRecordPresenter_Unloaded(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.FieldLayoutSettings.DataRecordPresenterStyle = xamDataGrid1.Resources["UnWire_DataRecordPresenter_Loaded"] as Style;
        }
    }

    public class person
    {
        public string Name { get; set; }
        public int Age { get; set; }
        public string Parameter { get; set; }
    }
}
